diff -uNr blt2.4z.orig/src/bltTabset.c blt2.4z/src/bltTabset.c
--- blt2.4z.orig/src/bltTabset.c	2002-09-18 18:30:51.000000000 -0400
+++ blt2.4z/src/bltTabset.c	2013-07-15 11:15:51.000000000 -0400
@@ -2812,7 +2812,7 @@
     GC newGC;
 
     tabSet = setPtr;
-    if (Tk_ConfigureWidget(interp, setPtr->tkwin, configSpecs, argc, argv,
+    if (Blt_ConfigureWidget(interp, setPtr->tkwin, configSpecs, argc, argv,
 	    (char *)setPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
@@ -3818,7 +3818,7 @@
 	}
 	tabSet = setPtr;
 	Tcl_Preserve(tabPtr);
-	result = Tk_ConfigureWidget(interp, setPtr->tkwin, tabConfigSpecs,
+	result = Blt_ConfigureWidget(interp, setPtr->tkwin, tabConfigSpecs,
 	    nOpts, options, (char *)tabPtr, TK_CONFIG_ARGV_ONLY);
 	if (result == TCL_OK) {
 	    result = ConfigureTab(setPtr, tabPtr);
diff -uNr blt2.4z.orig/src/bltTed.c blt2.4z/src/bltTed.c
--- blt2.4z.orig/src/bltTed.c	2002-05-16 16:46:00.000000000 -0400
+++ blt2.4z/src/bltTed.c	2013-07-15 11:15:51.000000000 -0400
@@ -29,6 +29,12 @@
 
 #include "bltTable.h"
 
+#if TCL_MAJOR_VERSION <=8 && TCL_MINOR_VERSION < 6
+#define Tcl_GetStringResult(x) x->result
+#define Tcl_GetErrorLine(x) x->errorLine
+#define Tcl_SetResult(x, y, z) x->result = y
+#endif
+
 extern Tk_CustomOption bltDistanceOption;
 extern Tk_CustomOption bltDashesOption;
 
@@ -826,7 +832,7 @@
     GC newGC;
     unsigned long gcMask;
 
-    if (Tk_ConfigureWidget(tedPtr->interp, tedPtr->tkwin, configSpecs,
+    if (Blt_ConfigureWidget(tedPtr->interp, tedPtr->tkwin, configSpecs,
 	    argc, argv, (char *)tedPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
@@ -1504,7 +1510,7 @@
 	tablePtr->flags |= ARRANGE_PENDING;
 	Tcl_DoWhenIdle(tablePtr->arrangeProc, tablePtr);
     }
-    interp->result = Tk_PathName(tedPtr->tkwin);
+    Tcl_SetResult(interp, (char* )Tk_PathName(tedPtr->tkwin), TCL_VOLATILE);
     tedPtr->flags |= LAYOUT_PENDING;
     EventuallyRedraw(tedPtr);
     return TCL_OK;
@@ -1678,7 +1684,7 @@
 	    tedPtr->activeRectArr[4].width = grip - 1;
 	    tedPtr->activeRectArr[4].height = grip - 1;
 
-	    interp->result = Tk_PathName(entryPtr->tkwin);
+	    Tcl_SetResult (interp, (char *)Tk_PathName(entryPtr->tkwin), TCL_VOLATILE);
 	    active = 1;
 	    break;
 	}
@@ -1751,7 +1757,7 @@
 	tablePtr->flags |= ARRANGE_PENDING;
 	Tcl_DoWhenIdle(tablePtr->arrangeProc, tablePtr);
     }
-    interp->result = Tk_PathName(tedPtr->tkwin);
+    Tcl_SetResult (interp, (char *)Tk_PathName(tedPtr->tkwin), TCL_VOLATILE);
     tedPtr->flags |= LAYOUT_PENDING;
     EventuallyRedraw(tedPtr);
     return TCL_OK;
diff -uNr blt2.4z.orig/src/bltText.c blt2.4z/src/bltText.c
--- blt2.4z.orig/src/bltText.c	2002-08-13 15:45:20.000000000 -0400
+++ blt2.4z/src/bltText.c	2013-07-15 11:15:51.000000000 -0400
@@ -35,28 +35,196 @@
 static int initialized;
 
 static void
-DrawTextLayout(display, drawable, gc, font, x, y, textPtr)
+Blt_AverageImage(im, w, h, d)
+     XImage *im;
+     unsigned int w, h, d;
+{
+  /* the image will end up with 1 or 0 in the first plane, rest zero */
+  int i, j, k;
+  unsigned int d2;
+  unsigned long pixel, pixelave;
+
+  d2 = (3*d)/4;
+  for (i=0 ; i<w ; i++) {
+    for (j=0 ; j<h ; j++) {
+      pixel = XGetPixel(im, i, j);
+      pixelave = pixel & 1;
+      for (k=1 ; k<d ; k++) {
+	pixel >>= 1;
+	pixelave += pixel & 1;
+      }
+      pixelave = (pixelave + d2)/d;
+      XPutPixel(im, i, j, pixelave);
+    }
+  }
+  return;
+}
+
+static void
+Blt_DrawCharsBitmap(display, bitmap, w, width, height, gc, font, x, y, textPtr)
+    Display *display;
+    Drawable bitmap;
+    Window w;
+    unsigned int width, height;
+    GC gc;
+    Tk_Font font;
+    register int x, y;
+    TextLayout *textPtr;
+{
+  register TextFragment *fragPtr;
+  register int i, j;
+
+  XImage *bitmapimage, *pixmapimage;
+  GC gcsave, gcp;
+  Window winr;
+  int xr, yr;
+  unsigned int wr, hr, br, dr;
+  Pixmap pixmap;
+  unsigned long whitepixel;
+  XGCValues gcvalues ;
+  unsigned long valuemask, pixel ;
+
+  /* save the GC */
+  gcsave = XCreateGC(display, bitmap, 0, NULL);
+  XCopyGC(display, gc, 0, gcsave);
+  /* create a pixmap to draw chars to */
+  XGetGeometry(display, w, &winr, &xr, &yr, &wr, &hr, &br, &dr);
+  pixmap = Tk_GetPixmap(display, winr, width, height, dr);
+  /* get a GC for the pixmap, black(0) background, white(1) chars */
+  valuemask = (GCForeground|GCBackground) ;
+  gcvalues.foreground = gcvalues.background = 0 ;
+  gcp = XCreateGC(display, pixmap, valuemask, &gcvalues);
+  XSetForeground(display, gcp, 0) ;
+  XFillRectangle(display, pixmap, gcp, 0, 0, width, height);
+  whitepixel = XWhitePixel(display, 0);
+  XSetForeground(display, gcp, whitepixel) ;
+  /* draw white chars to the pixmap */
+  fragPtr = textPtr->fragArr;
+  for (i = 0; i < textPtr->nFrags; i++, fragPtr++) {
+#ifdef TK_DRAWCHARS_ANGLE
+    Tk_DrawChars(display, pixmap, gcp, font, fragPtr->text,
+		 fragPtr->count, x + fragPtr->x, y + fragPtr->y, 0);
+#else
+    Tk_DrawChars(display, pixmap, gcp, font, fragPtr->text,
+		 fragPtr->count, x + fragPtr->x, y + fragPtr->y);
+#endif
+  }
+  XFlush(display);
+  /* get the pixmap image */
+  pixmapimage = XGetImage(display, pixmap, 0, 0, width, height,
+			  AllPlanes, XYPixmap);
+  /* average the image to get the char in a single bit plane */
+  Blt_AverageImage(pixmapimage, width, height, dr);
+  /* get an image for the bitmap */
+  bitmapimage = XGetImage(display, bitmap, 0, 0, width, height,
+			  1, XYPixmap);
+  /* copy the first bit plane from the averaged pixmap to the bitmap */
+  for (i=0 ; i<width ; i++) {
+    for(j=0 ; j<height ; j++) {
+      pixel = XGetPixel(pixmapimage, i, j);
+      XPutPixel(bitmapimage, i, j, pixel);
+    }
+  }
+  /* but the bitmapimage into the bitmap with gc fg=1 bg=0 clipmask=None */
+  XSetForeground(display, gc, 1);
+  XSetBackground(display, gc, 0);
+  XSetClipMask(display, gc, None);
+  XPutImage(display, bitmap, gc, bitmapimage, 0, 0, 0, 0, width, height);
+  /* reset gc and clean up */
+  XCopyGC(display, gcsave, 0, gc);
+  XFreeGC(display, gcp);
+  XFreeGC(display, gcsave);
+  XDestroyImage(bitmapimage);
+  XDestroyImage(pixmapimage);
+  Tk_FreePixmap(display, pixmap);
+  return;
+}
+
+#ifdef TK_DRAWCHARS_ANGLE
+static void
+DrawTextLayout(display, drawable, gc, font, x, y, textPtr, angle)
     Display *display;
     Drawable drawable;
     GC gc;
     Tk_Font font;
     register int x, y;		/* Origin of text */
     TextLayout *textPtr;
+    double angle;
 {
     register TextFragment *fragPtr;
     register int i;
 
+#if HAVE_UTF
+    /*
+     * Tk_DrawChars no longer works on bitmaps for antialiased fonts
+     * Fix this by checking for a bitmap and calling code that
+     * DrawChars to bitmap
+     */
+    Window w;
+    int xd, yd;
+    unsigned int wd, hd, bd, dd;
+    XGetGeometry(display, drawable, &w, &xd, &yd, &wd, &hd, &bd, &dd);
+    if ( dd == 1 ) {
+      Blt_DrawCharsBitmap(display, drawable, w, wd, hd, gc, font,
+			  x, y, textPtr);
+      return;
+    }
     fragPtr = textPtr->fragArr;
     for (i = 0; i < textPtr->nFrags; i++, fragPtr++) {
+	Tk_DrawChars(display, drawable, gc, font, fragPtr->text,
+		     fragPtr->count, x + fragPtr->x, y + fragPtr->y, angle);
+    }
+#else
+    fragPtr = textPtr->fragArr;
+    for (i = 0; i < textPtr->nFrags; i++, fragPtr++) {
+	XDrawString(display, drawable, gc, x + fragPtr->x, y + fragPtr->y,
+	    fragPtr->text, fragPtr->count);
+    }
+#endif /*HAVE_UTF*/
+}
+
+#else  /* no angled drawing in Tk_DrawChars */
+static void
+DrawTextLayout(display, drawable, gc, font, x, y, textPtr)
+    Display *display;
+    Drawable drawable;
+    GC gc;
+    Tk_Font font;
+    register int x, y;		/* Origin of text */
+    TextLayout *textPtr;
+{
+    register TextFragment *fragPtr;
+    register int i;
+
 #if HAVE_UTF
+    /*
+     * Tk_DrawChars no longer works on bitmaps for antialiased fonts
+     * Fix this by checking for a bitmap and calling code that
+     * DrawChars to bitmap
+     */
+    Window w;
+    int xd, yd;
+    unsigned int wd, hd, bd, dd;
+    XGetGeometry(display, drawable, &w, &xd, &yd, &wd, &hd, &bd, &dd);
+    if ( dd == 1 ) {
+      Blt_DrawCharsBitmap(display, drawable, w, wd, hd, gc, font,
+			  x, y, textPtr);
+      return;
+    }
+    fragPtr = textPtr->fragArr;
+    for (i = 0; i < textPtr->nFrags; i++, fragPtr++) {
 	Tk_DrawChars(display, drawable, gc, font, fragPtr->text,
 	    fragPtr->count, x + fragPtr->x, y + fragPtr->y);
+    }
 #else
+    fragPtr = textPtr->fragArr;
+    for (i = 0; i < textPtr->nFrags; i++, fragPtr++) {
 	XDrawString(display, drawable, gc, x + fragPtr->x, y + fragPtr->y,
 	    fragPtr->text, fragPtr->count);
-#endif /*HAVE_UTF*/
     }
+#endif /*HAVE_UTF*/
 }
+#endif /* TK_DRAWCHARS_ANGLE */
 
 /*
  * -----------------------------------------------------------------
@@ -657,6 +825,8 @@
  *
  * -----------------------------------------------------------------
  */
+
+#ifdef TK_DRAWCHARS_ANGLE
 void
 Blt_DrawTextLayout(tkwin, drawable, textPtr, tsPtr, x, y)
     Tk_Window tkwin;
@@ -671,6 +841,90 @@
     Pixmap bitmap;
     int active;
 
+    if (!textPtr)
+	return;
+    
+    display = Tk_Display(tkwin);
+    theta = FMOD(tsPtr->theta, (double)360.0);
+    if (theta < 0.0) {
+	theta += 360.0;
+    }
+
+#ifdef WIN32
+    if ( theta > 0. ) {
+      if (Blt_DrawRotatedText(display, drawable, x, y, theta, tsPtr, textPtr)) {
+	return;
+      }
+    }
+#endif
+
+    active = tsPtr->state & STATE_ACTIVE;
+
+    width = textPtr->width, height = textPtr->height;
+    Blt_TranslateAnchor(x, y, width, height, tsPtr->anchor, &x, &y);
+    if (tsPtr->state & (STATE_DISABLED | STATE_EMPHASIS)) {
+      TkBorder *borderPtr = (TkBorder *) tsPtr->border;
+      XColor *color1, *color2;
+
+      color1 = borderPtr->lightColor, color2 = borderPtr->darkColor;
+      if (tsPtr->state & STATE_EMPHASIS) {
+	XColor *hold;
+	
+	hold = color1, color1 = color2, color2 = hold;
+      }
+      if (color1 != NULL) {
+	XSetForeground(display, tsPtr->gc, color1->pixel);
+      }
+      DrawTextLayout(display, drawable, tsPtr->gc, tsPtr->font, x + 1, 
+		     y + 1, textPtr, theta);
+      if (color2 != NULL) {
+	XSetForeground(display, tsPtr->gc, color2->pixel);
+      }
+      DrawTextLayout(display, drawable, tsPtr->gc, tsPtr->font, x, y, 
+		     textPtr, theta);
+      
+      /* Reset the foreground color back to its original setting,
+       * so not to invalidate the GC cache. */
+      XSetForeground(display, tsPtr->gc, tsPtr->color->pixel);
+      
+      return;		/* Done */
+    }
+    if ((tsPtr->shadow.offset > 0) && (tsPtr->shadow.color != NULL)) {
+      XSetForeground(display, tsPtr->gc, tsPtr->shadow.color->pixel);
+      DrawTextLayout(display, drawable, tsPtr->gc, tsPtr->font, 
+		     x + tsPtr->shadow.offset, y + tsPtr->shadow.offset,
+		     textPtr, theta);
+      XSetForeground(display, tsPtr->gc, tsPtr->color->pixel);
+    }
+    if (active) {
+      XSetForeground(display, tsPtr->gc, tsPtr->activeColor->pixel);
+    }
+    DrawTextLayout(display, drawable, tsPtr->gc, tsPtr->font, x, y, 
+		   textPtr, theta);
+    if (active) {
+      XSetForeground(display, tsPtr->gc, tsPtr->color->pixel);
+    }
+    return;			/* Done */
+}
+
+#else  /* NO TK_DRAWCHARS_ANGLE */
+void
+Blt_DrawTextLayout(tkwin, drawable, textPtr, tsPtr, x, y)
+    Tk_Window tkwin;
+    Drawable drawable;
+    TextLayout *textPtr;
+    TextStyle *tsPtr;		/* Text attribute information */
+    int x, y;			/* Window coordinates to draw text */
+{
+    int width, height;
+    double theta;
+    Display *display;
+    Pixmap bitmap;
+    int active;
+
+    if (!textPtr)
+	return;
+    
     display = Tk_Display(tkwin);
     theta = FMOD(tsPtr->theta, (double)360.0);
     if (theta < 0.0) {
@@ -795,6 +1049,7 @@
     XSetClipMask(display, tsPtr->gc, None);
     Tk_FreePixmap(display, bitmap);
 }
+#endif   /* TK_DRAWCHARS_ANGLE */
 
 void
 Blt_DrawText2(tkwin, drawable, string, tsPtr, x, y, areaPtr)
diff -uNr blt2.4z.orig/src/bltTree.c blt2.4z/src/bltTree.c
--- blt2.4z.orig/src/bltTree.c	2002-09-29 01:44:12.000000000 -0400
+++ blt2.4z/src/bltTree.c	2013-07-15 11:15:51.000000000 -0400
@@ -95,17 +95,16 @@
  */
 
 #define REBUILD_MULTIPLIER	3
+#define START_LOGSIZE		5 /* Initial hash table size is 32. */
+#define MAX_LIST_VALUES		20 /* Convert to hash table when node
+				    * value list gets bigger than this
+				    * many values. */
 
 #if (SIZEOF_VOID_P == 8)
 #define RANDOM_INDEX(i)		HashOneWord(mask, downshift, i)
 #define BITSPERWORD		64
 #else 
 
-#define START_LOGSIZE		5 /* Initial hash table size is 32. */
-#define MAX_LIST_VALUES		20 /* Convert to hash table when node
-				    * value list gets bigger than this
-				    * many values. */
-
 /*
  * The following macro takes a preliminary integer hash value and
  * produces an index into a hash tables bucket list.  The idea is
@@ -403,7 +402,7 @@
     TreeDestroyValues(nodePtr);
     UnlinkNode(nodePtr);
     treeObjPtr->nNodes--;
-    hPtr = Blt_FindHashEntry(&treeObjPtr->nodeTable, (char *)nodePtr->inode);
+    hPtr = Blt_FindHashEntry(&treeObjPtr->nodeTable, (char *)(uintptr_t)nodePtr->inode);
     assert(hPtr);
     Blt_DeleteHashEntry(&treeObjPtr->nodeTable, hPtr);
     Blt_PoolFreeItem(treeObjPtr->nodePool, (char *)nodePtr);
@@ -836,7 +835,7 @@
     /* Generate an unique serial number for this node.  */
     do {
 	inode = treeObjPtr->nextInode++;
-	hPtr = Blt_CreateHashEntry(&treeObjPtr->nodeTable,(char *)inode, 
+	hPtr = Blt_CreateHashEntry(&treeObjPtr->nodeTable,(char *)(uintptr_t)inode, 
 		   &isNew);
     } while (!isNew);
     nodePtr = NewNode(treeObjPtr, name, inode);
@@ -891,7 +890,7 @@
     int isNew;
 
     treeObjPtr = parentPtr->treeObject;
-    hPtr = Blt_CreateHashEntry(&treeObjPtr->nodeTable,(char *)inode, &isNew);
+    hPtr = Blt_CreateHashEntry(&treeObjPtr->nodeTable,(char *)(uintptr_t)inode, &isNew);
     if (!isNew) {
 	return NULL;
     }
@@ -997,7 +996,7 @@
     TreeObject *treeObjPtr = clientPtr->treeObject;
     Blt_HashEntry *hPtr;
 
-    hPtr = Blt_FindHashEntry(&treeObjPtr->nodeTable, (char *)inode);
+    hPtr = Blt_FindHashEntry(&treeObjPtr->nodeTable, (char *)(uintptr_t)inode);
     if (hPtr != NULL) {
 	return (Blt_TreeNode)Blt_GetHashValue(hPtr);
     }
diff -uNr blt2.4z.orig/src/bltTreeCmd.c blt2.4z/src/bltTreeCmd.c
--- blt2.4z.orig/src/bltTreeCmd.c	2002-09-27 18:23:01.000000000 -0400
+++ blt2.4z/src/bltTreeCmd.c	2013-07-15 11:15:51.000000000 -0400
@@ -950,7 +950,7 @@
     Tcl_Interp *interp = cmdPtr->interp;
     Blt_Tree tree = cmdPtr->tree;
     char c;
-    Blt_TreeNode node;
+    Blt_TreeNode node=NULL;
     char *string;
     char *p;
 
@@ -1283,7 +1283,7 @@
     if (parentId == -1) {	/* Dump marks root's parent as -1. */
 	node = dataPtr->root;
 	/* Create a mapping between the old id and the new node */
-	hPtr = Blt_CreateHashEntry(&dataPtr->idTable, (char *)nodeId, 
+	hPtr = Blt_CreateHashEntry(&dataPtr->idTable, (char *)(uintptr_t)nodeId, 
 		   &isNew);
 	Blt_SetHashValue(hPtr, node);
 	Blt_TreeRelabelNode(cmdPtr->tree, node, names[0]);
@@ -1293,7 +1293,7 @@
 	 * This can happen when there's a id collision with an
 	 * existing node. 
 	 */
-	hPtr = Blt_FindHashEntry(&dataPtr->idTable, (char *)parentId);
+	hPtr = Blt_FindHashEntry(&dataPtr->idTable, (char *)(uintptr_t)parentId);
 	if (hPtr != NULL) {
 	    parent = Blt_GetHashValue(hPtr);
 	} else {
@@ -1330,7 +1330,7 @@
 	if (dataPtr->flags & RESTORE_OVERWRITE) {
 	    node = Blt_TreeFindChild(parent, names[nNames - 1]);
 	    /* Create a mapping between the old id and the new node */
-	    hPtr = Blt_CreateHashEntry(&dataPtr->idTable, (char *)nodeId, 
+	    hPtr = Blt_CreateHashEntry(&dataPtr->idTable, (char *)(uintptr_t)nodeId, 
 				       &isNew);
 	    Blt_SetHashValue(hPtr, node);
 	}
@@ -1340,7 +1340,7 @@
 		node = Blt_TreeCreateNode(cmdPtr->tree, parent, 
 					  names[nNames - 1], -1);
 		/* Create a mapping between the old id and the new node */
-		hPtr = Blt_CreateHashEntry(&dataPtr->idTable, (char *)nodeId,
+		hPtr = Blt_CreateHashEntry(&dataPtr->idTable, (char *)(uintptr_t)nodeId,
 					   &isNew);
 		Blt_SetHashValue(hPtr, node);
 	    } else {
@@ -1667,7 +1667,7 @@
     for (node = Blt_ListFirstNode(patternList); node != NULL; 
 	node = Blt_ListNextNode(node)) {
 		
-	type = (int)Blt_ListGetValue(node);
+	type = (int)(uintptr_t)Blt_ListGetValue(node);
 	pattern = (char *)Blt_ListGetKey(node);
 	switch (type) {
 	case PATTERN_EXACT:
@@ -2602,7 +2602,7 @@
 	    for (hPtr = Blt_FirstHashEntry(tablePtr, &cursor); 
 		hPtr != NULL; hPtr = Blt_NextHashEntry(&cursor)) {
 		node = Blt_GetHashValue(hPtr);
-		Blt_ChainAppend(chainPtr, (ClientData)Blt_TreeNodeId(node));
+		Blt_ChainAppend(chainPtr, (ClientData)(uintptr_t)Blt_TreeNodeId(node));
 	    }   
 	    /*  
 	     * Iterate through this list to delete the nodes.  By
@@ -2612,7 +2612,7 @@
 	    for (linkPtr = Blt_ChainFirstLink(chainPtr); linkPtr != NULL;
 		 linkPtr = nextPtr) {
 		nextPtr = Blt_ChainNextLink(linkPtr);
-		inode = (int)Blt_ChainGetValue(linkPtr);
+		inode = (int)(uintptr_t)Blt_ChainGetValue(linkPtr);
 		node = Blt_TreeGetNode(cmdPtr->tree, inode);
 		if (node != NULL) {
 		    DeleteNode(cmdPtr, node);
diff -uNr blt2.4z.orig/src/bltTreeView.c blt2.4z/src/bltTreeView.c
--- blt2.4z.orig/src/bltTreeView.c	2002-08-16 00:15:04.000000000 -0400
+++ blt2.4z/src/bltTreeView.c	2013-07-15 11:15:51.000000000 -0400
@@ -1055,10 +1055,10 @@
     if (isNew) {
 	refCount = 1;
     } else {
-	refCount = (int)Blt_GetHashValue(hPtr);
+	refCount = (int)(uintptr_t)Blt_GetHashValue(hPtr);
 	refCount++;
     }
-    Blt_SetHashValue(hPtr, (ClientData)refCount);
+    Blt_SetHashValue(hPtr, (ClientData)(uintptr_t)refCount);
     return Blt_GetHashKey(&tvPtr->uidTable, hPtr);
 }
 
@@ -1084,10 +1084,10 @@
 
     hPtr = Blt_FindHashEntry(&tvPtr->uidTable, uid);
     assert(hPtr != NULL);
-    refCount = (int)Blt_GetHashValue(hPtr);
+    refCount = (int)(uintptr_t)Blt_GetHashValue(hPtr);
     refCount--;
     if (refCount > 0) {
-	Blt_SetHashValue(hPtr, (ClientData)refCount);
+	Blt_SetHashValue(hPtr, (ClientData)(uintptr_t)refCount);
     } else {
 	Blt_DeleteHashEntry(&tvPtr->uidTable, hPtr);
     }
@@ -3866,6 +3866,7 @@
 	assert(tvPtr->visibleArr);
     }
     tvPtr->nVisible = 0;
+    tvPtr->visibleArr[0] = NULL;
 
     if (tvPtr->rootPtr->flags & ENTRY_HIDDEN) {
 	return TCL_OK;		/* Root node is hidden. */
@@ -4022,7 +4023,7 @@
 {
     int height, level;
     int x, y;
-    int x1, y1, x2, y2;
+    int x1, y1i, x2, y2;
 
     while (entryPtr != tvPtr->rootPtr) {
 	entryPtr = Blt_TreeViewParentEntry(entryPtr);
@@ -4042,24 +4043,24 @@
 		tvPtr->button.height);
 	y += (height - tvPtr->button.height) / 2;
 	x1 = x2 = x + ICONWIDTH(level) + ICONWIDTH(level + 1) / 2;
-	y1 = y + tvPtr->button.height / 2;
-	y2 = y1 + entryPtr->vertLineLength;
+	y1i = y + tvPtr->button.height / 2;
+	y2 = y1i + entryPtr->vertLineLength;
 	if ((entryPtr == tvPtr->rootPtr) && (tvPtr->flags & TV_HIDE_ROOT)) {
-	    y1 += entryPtr->height;
+	    y1i += entryPtr->height;
 	}
 	/*
 	 * Clip the line's Y-coordinates at the viewport borders.
 	 */
-	if (y1 < 0) {
-	    y1 = (y1 & 0x1);	/* Make sure the dotted line starts on 
+	if (y1i < 0) {
+	    y1i = (y1i & 0x1);	/* Make sure the dotted line starts on 
 				 * the same even/odd pixel. */
 	}
 	if (y2 > Tk_Height(tvPtr->tkwin)) {
 	    y2 = Tk_Height(tvPtr->tkwin);
 	}
-	if ((y1 < Tk_Height(tvPtr->tkwin)) && (y2 > 0)) {
+	if ((y1i < Tk_Height(tvPtr->tkwin)) && (y2 > 0)) {
 	    XDrawLine(tvPtr->display, drawable, tvPtr->lineGC, 
-	      x1, y1, x2, y2);
+	      x1, y1i, x2, y2);
 	}
     }
 }
@@ -4071,14 +4072,14 @@
     TreeViewColumn *columnPtr,
     Drawable drawable)		/* Pixmap or window to draw into. */
 {
-    int x, y1, y2;
+    int x, y1i, y2;
 
     x = SCREENX(tvPtr, columnPtr->worldX) + 
 	columnPtr->width + tvPtr->ruleMark - tvPtr->ruleAnchor - 1;
 
-    y1 = tvPtr->titleHeight + tvPtr->inset;
+    y1i = tvPtr->titleHeight + tvPtr->inset;
     y2 = Tk_Height(tvPtr->tkwin) - tvPtr->inset;
-    XDrawLine(tvPtr->display, drawable, columnPtr->ruleGC, x, y1, x, y2);
+    XDrawLine(tvPtr->display, drawable, columnPtr->ruleGC, x, y1i, x, y2);
     tvPtr->flags = TOGGLE(tvPtr->flags, TV_RULE_ACTIVE);
 }
 
@@ -4526,7 +4527,7 @@
     int level;
     int width, height;
     int x, y;
-    int x1, y1, x2, y2;
+    int x1, y1i, x2, y2;
 
     entryPtr->flags &= ~ENTRY_REDRAW;
 
@@ -4544,7 +4545,7 @@
     buttonY = y + entryPtr->buttonY;
 
     x1 = x + (width / 2);
-    y1 = y2 = buttonY + (buttonPtr->height / 2);
+    y1i = y2 = buttonY + (buttonPtr->height / 2);
     x2 = x1 + (ICONWIDTH(level) + ICONWIDTH(level + 1)) / 2;
 
     if ((Blt_TreeNodeParent(entryPtr->node) != NULL) && 
@@ -4553,17 +4554,17 @@
 	 * For every node except root, draw a horizontal line from
 	 * the vertical bar to the middle of the icon.
 	 */
-	XDrawLine(tvPtr->display, drawable, tvPtr->lineGC, x1, y1, x2, y2);
+	XDrawLine(tvPtr->display, drawable, tvPtr->lineGC, x1, y1i, x2, y2);
     }
     if (((entryPtr->flags & ENTRY_CLOSED) == 0) && (tvPtr->lineWidth > 0)) {
 	/*
 	 * Entry is open, draw vertical line.
 	 */
-	y2 = y1 + entryPtr->vertLineLength;
+	y2 = y1i + entryPtr->vertLineLength;
 	if (y2 > Tk_Height(tvPtr->tkwin)) {
 	    y2 = Tk_Height(tvPtr->tkwin); /* Clip line at window border. */
 	}
-	XDrawLine(tvPtr->display, drawable, tvPtr->lineGC, x2, y1, x2, y2);
+	XDrawLine(tvPtr->display, drawable, tvPtr->lineGC, x2, y1i, x2, y2);
     }
     if ((entryPtr->flags & ENTRY_HAS_BUTTON) && (entryPtr != tvPtr->rootPtr)) {
 	/*
@@ -4631,6 +4632,9 @@
     int width;
     int x0, cx, xOffset;
 
+    if (tvPtr->titleHeight < 1) {
+	return;
+    }
     columnWidth = columnPtr->width;
     cx = x;
     if (columnPtr->position == Blt_ChainGetLength(tvPtr->colChainPtr)) {
diff -uNr blt2.4z.orig/src/bltTreeViewEdit.c blt2.4z/src/bltTreeViewEdit.c
--- blt2.4z.orig/src/bltTreeViewEdit.c	2002-09-14 16:07:43.000000000 -0400
+++ blt2.4z/src/bltTreeViewEdit.c	2013-07-15 11:15:51.000000000 -0400
@@ -1177,9 +1177,15 @@
 	rightPos = count;
 	if ((rightPos < tbPtr->selFirst) || (leftPos > tbPtr->selLast)) {
 	    /* No part of the text fragment is selected. */
+#ifdef TK_DRAWCHARS_ANGLE
+	    Tk_DrawChars(tbPtr->display, drawable, tbPtr->gc, 
+			 tbPtr->font, fragPtr->text, fragPtr->count, 
+			 x + fragPtr->x, y + fragPtr->y, 0.);
+#else
 	    Tk_DrawChars(tbPtr->display, drawable, tbPtr->gc, 
 			 tbPtr->font, fragPtr->text, fragPtr->count, 
 			 x + fragPtr->x, y + fragPtr->y);
+#endif
 	    continue;
 	}
 
@@ -1221,9 +1227,15 @@
 	        width, fontMetrics.linespace,
 		tbPtr->selBorderWidth, tbPtr->selRelief);
 	}
+#ifdef TK_DRAWCHARS_ANGLE
+	Tk_DrawChars(Tk_Display(tbPtr->tkwin), drawable, tbPtr->gc, 
+	     tbPtr->font, fragPtr->text, fragPtr->count, 
+		     fragPtr->x + x, fragPtr->y + y, 0.);
+#else
 	Tk_DrawChars(Tk_Display(tbPtr->tkwin), drawable, tbPtr->gc, 
 	     tbPtr->font, fragPtr->text, fragPtr->count, 
 	     fragPtr->x + x, fragPtr->y + y);
+#endif
     }
     if ((tbPtr->flags & TEXTBOX_FOCUS) && (tbPtr->cursorOn)) {
 	int left, top, right, bottom;
diff -uNr blt2.4z.orig/src/bltTreeViewStyle.c blt2.4z/src/bltTreeViewStyle.c
--- blt2.4z.orig/src/bltTreeViewStyle.c	2002-07-22 18:18:40.000000000 -0400
+++ blt2.4z/src/bltTreeViewStyle.c	2013-07-15 11:15:51.000000000 -0400
@@ -846,6 +846,11 @@
  *----------------------------------------------------------------------
  */
 /*ARGSUSED*/
+
+int
+Blt_TreeViewTextbox(TreeView *tvPtr,
+		    TreeViewEntry *entryPtr,
+		    TreeViewColumn *columnPtr);
 static int
 EditTextBox(tvPtr, entryPtr, valuePtr, stylePtr)
     TreeView *tvPtr;
diff -uNr blt2.4z.orig/src/bltUnixDnd.c blt2.4z/src/bltUnixDnd.c
--- blt2.4z.orig/src/bltUnixDnd.c	2002-07-13 20:08:56.000000000 -0400
+++ blt2.4z/src/bltUnixDnd.c	2013-07-15 11:15:51.000000000 -0400
@@ -1834,7 +1834,7 @@
     unsigned long gcMask;
 
     Tk_MakeWindowExist(tokenPtr->tkwin);
-    if (Tk_ConfigureWidget(interp, tokenPtr->tkwin, tokenConfigSpecs, argc, 
+    if (Blt_ConfigureWidget(interp, tokenPtr->tkwin, tokenConfigSpecs, argc, 
 		argv, (char *)tokenPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
@@ -3777,7 +3777,7 @@
 	return Tk_ConfigureInfo(interp, dndPtr->tkwin, configSpecs,
 	    (char *)dndPtr, argv[3], flags);
     } 
-    if (Tk_ConfigureWidget(interp, dndPtr->tkwin, configSpecs, argc - 3,
+    if (Blt_ConfigureWidget(interp, dndPtr->tkwin, configSpecs, argc - 3,
 		   argv + 3, (char *)dndPtr, flags) != TCL_OK) {
 	return TCL_ERROR;
     }
@@ -4440,7 +4440,7 @@
     dndPtr->hashPtr = hPtr;
     dndPtr->dataPtr = dataPtr;
     Blt_SetHashValue(hPtr, dndPtr);
-    if (Tk_ConfigureWidget(interp, dndPtr->tkwin, configSpecs, argc - 3,
+    if (Blt_ConfigureWidget(interp, dndPtr->tkwin, configSpecs, argc - 3,
 	   argv + 3, (char *)dndPtr, 0) != TCL_OK) {
 	return TCL_ERROR;
     }
diff -uNr blt2.4z.orig/src/bltUnixImage.c blt2.4z/src/bltUnixImage.c
--- blt2.4z.orig/src/bltUnixImage.c	2002-08-16 00:15:04.000000000 -0400
+++ blt2.4z/src/bltUnixImage.c	2013-07-15 11:15:51.000000000 -0400
@@ -574,7 +574,7 @@
 	destPtr = Blt_ColorImageBits(image);
 	endPtr = destPtr + nPixels;
 	for (/* empty */; destPtr < endPtr; destPtr++) {
-	    hPtr = Blt_FindHashEntry(&pixelTable, (char *)destPtr->value);
+	    hPtr = Blt_FindHashEntry(&pixelTable, (char *)(uintptr_t)destPtr->value);
 	    colorPtr = (XColor *)Blt_GetHashValue(hPtr);
 	    destPtr->Red = lut[colorPtr->red >> 8];
 	    destPtr->Green = lut[colorPtr->green >> 8];
diff -uNr blt2.4z.orig/src/bltUnixPipe.c blt2.4z/src/bltUnixPipe.c
--- blt2.4z.orig/src/bltUnixPipe.c	2002-06-22 15:21:05.000000000 -0400
+++ blt2.4z/src/bltUnixPipe.c	2013-07-15 11:15:51.000000000 -0400
@@ -477,7 +477,7 @@
 	 * Reap the child process now if an error occurred during its
 	 * startup.
 	 */
-	Tcl_WaitPid((Tcl_Pid)pid, &status, WNOHANG);
+	Tcl_WaitPid((Tcl_Pid)(uintptr_t)pid, &status, WNOHANG);
     }
     if (errPipeIn >= 0) {
 	CloseFile(errPipeIn);
diff -uNr blt2.4z.orig/src/bltUtil.c blt2.4z/src/bltUtil.c
--- blt2.4z.orig/src/bltUtil.c	2002-08-21 16:13:12.000000000 -0400
+++ blt2.4z/src/bltUtil.c	2013-07-15 11:15:51.000000000 -0400
@@ -793,10 +793,10 @@
     if (isNew) {
 	refCount = 0;
     } else {
-	refCount = (int)Blt_GetHashValue(hPtr);
+	refCount = (int)(uintptr_t)Blt_GetHashValue(hPtr);
     }
     refCount++;
-    Blt_SetHashValue(hPtr, (ClientData)refCount);
+    Blt_SetHashValue(hPtr, (ClientData)(uintptr_t)refCount);
     return (Blt_Uid)Blt_GetHashKey(&uidTable, hPtr);
 }
 
@@ -830,12 +830,12 @@
     if (hPtr) {
 	int refCount;
 
-	refCount = (int)Blt_GetHashValue(hPtr);
+	refCount = (int)(uintptr_t)Blt_GetHashValue(hPtr);
 	refCount--;
 	if (refCount == 0) {
 	    Blt_DeleteHashEntry(&uidTable, hPtr);
 	} else {
-	    Blt_SetHashValue(hPtr, (ClientData)refCount);
+	    Blt_SetHashValue(hPtr, (ClientData)(uintptr_t)refCount);
 	}
     } else {
 	fprintf(stderr, "tried to release unknown identifier \"%s\"\n", uid);
diff -uNr blt2.4z.orig/src/bltVecMath.c blt2.4z/src/bltVecMath.c
--- blt2.4z.orig/src/bltVecMath.c	2002-09-10 01:12:33.000000000 -0400
+++ blt2.4z/src/bltVecMath.c	2013-07-15 11:15:51.000000000 -0400
@@ -28,6 +28,12 @@
 
 #include "bltVecInt.h"
 
+#if TCL_MAJOR_VERSION <=8 && TCL_MINOR_VERSION < 6
+#define Tcl_GetStringResult(x) x->result
+#define Tcl_GetErrorLine(x) x->errorLine
+#define Tcl_SetResult(x, y, z) x->result = y
+#endif
+
 /*
  * Three types of math functions:
  *
@@ -764,20 +770,20 @@
     if ((errno == EDOM) || (value != value)) {
 	Tcl_AppendResult(interp, "domain error: argument not in valid range",
 	    (char *)NULL);
-	Tcl_SetErrorCode(interp, "ARITH", "DOMAIN", interp->result,
+	Tcl_SetErrorCode(interp, "ARITH", "DOMAIN", Tcl_GetStringResult(interp),
 	    (char *)NULL);
     } else if ((errno == ERANGE) || IS_INF(value)) {
 	if (value == 0.0) {
 	    Tcl_AppendResult(interp, 
 			     "floating-point value too small to represent",
 		(char *)NULL);
-	    Tcl_SetErrorCode(interp, "ARITH", "UNDERFLOW", interp->result,
+	    Tcl_SetErrorCode(interp, "ARITH", "UNDERFLOW", Tcl_GetStringResult(interp),
 		(char *)NULL);
 	} else {
 	    Tcl_AppendResult(interp, 
 			     "floating-point value too large to represent",
 		(char *)NULL);
-	    Tcl_SetErrorCode(interp, "ARITH", "OVERFLOW", interp->result,
+	    Tcl_SetErrorCode(interp, "ARITH", "OVERFLOW", Tcl_GetStringResult(interp),
 		(char *)NULL);
 	}
     } else {
@@ -786,7 +792,7 @@
 	sprintf(buf, "%d", errno);
 	Tcl_AppendResult(interp, "unknown floating-point error, ",
 	    "errno = ", buf, (char *)NULL);
-	Tcl_SetErrorCode(interp, "ARITH", "UNKNOWN", interp->result,
+	Tcl_SetErrorCode(interp, "ARITH", "UNKNOWN", Tcl_GetStringResult(interp),
 	    (char *)NULL);
     }
 }
diff -uNr blt2.4z.orig/src/bltWinDraw.c blt2.4z/src/bltWinDraw.c
--- blt2.4z.orig/src/bltWinDraw.c	2002-09-07 16:38:08.000000000 -0400
+++ blt2.4z/src/bltWinDraw.c	2013-07-15 11:15:51.000000000 -0400
@@ -1647,8 +1647,13 @@
     if (drawable == None) {
 	return;
     }
+#ifdef TK_DRAWCHARS_ANGLE
+    Tk_DrawChars(display, drawable, gc, (Tk_Font)gc->font, string, length, 
+		 x, y, 0.);
+#else
     Tk_DrawChars(display, drawable, gc, (Tk_Font)gc->font, string, length, 
 	x, y);
+#endif
 }
 
 static void
